Subject: Re: bug#55283: ‘tests/guix-shell-export-manifest.sh’ fails on aarch64-linux

From: Vagrant Cascadian <[email-masked]>
Date: Fri, 06 May 2022 17:14:45 -0700

On 2022-05-06, Vagrant Cascadian wrote:
> On 2022-05-06, Maxime Devos wrote:
>> raingloom schreef op vr 06-05-2022 om 02:28 [+0200]:
>>> > …)) In guix/cpu.scm:
>>> >       94:2  0 (cpu->gcc-architecture #f)
>>> 
>>> This indicates the same to me.
>>> But I don't know the internals of --tune well enough, so it's just a
>>> hunch.
>>
>> Could anyone who encounters the issue on aarch64-linux send their
>> /proc/cpuinfo, such that other people can test the body of 'current-
>> cpu' on that copy?

What is reading from /proc/cpuinfo? I've heard it suggested that
/proc/cpuinfo was more informational and not something to be relied on
for anything that actually matters... ?

Well, I guess I answered my initial question by reading the error
message... guix/cpu.scm ... how did that work before for things like
cross-building, where /proc/cpuinfo is *definitely* wrong to get
information about the architecture you're building for?

> On a rockpro64:
>
> $ cat /proc/cpuinfo
> processor       : 0
> BogoMIPS        : 48.00
> Features        : fp asimd evtstrm aes pmull sha1 sha2 crc32 cpuid
> CPU implementer : 0x41
> CPU architecture: 8
> CPU variant     : 0x0
> CPU part        : 0xd03
> CPU revision    : 4
...
> I'll test on some other hardware with a very different cpu and see if it
> has the same problem too.

And on an APM mustang:

$ cat /proc/cpuinfo
processor       : 0
BogoMIPS        : 100.00
Features        : fp asimd evtstrm cpuid
CPU implementer : 0x50
CPU architecture: 8
CPU variant     : 0x0
CPU part        : 0x000
CPU revision    : 0

processor       : 1
BogoMIPS        : 100.00
Features        : fp asimd evtstrm cpuid
CPU implementer : 0x50
CPU architecture: 8
CPU variant     : 0x0
CPU part        : 0x000
CPU revision    : 0

processor       : 2
BogoMIPS        : 100.00
Features        : fp asimd evtstrm cpuid
CPU implementer : 0x50
CPU architecture: 8
CPU variant     : 0x0
CPU part        : 0x000
CPU revision    : 0

processor       : 3
BogoMIPS        : 100.00
Features        : fp asimd evtstrm cpuid
CPU implementer : 0x50
CPU architecture: 8
CPU variant     : 0x0
CPU part        : 0x000
CPU revision    : 0

processor       : 4
BogoMIPS        : 100.00
Features        : fp asimd evtstrm cpuid
CPU implementer : 0x50
CPU architecture: 8
CPU variant     : 0x0
CPU part        : 0x000
CPU revision    : 0

processor       : 5
BogoMIPS        : 100.00
Features        : fp asimd evtstrm cpuid
CPU implementer : 0x50
CPU architecture: 8
CPU variant     : 0x0
CPU part        : 0x000
CPU revision    : 0

processor       : 6
BogoMIPS        : 100.00
Features        : fp asimd evtstrm cpuid
CPU implementer : 0x50
CPU architecture: 8
CPU variant     : 0x0
CPU part        : 0x000
CPU revision    : 0

processor       : 7
BogoMIPS        : 100.00
Features        : fp asimd evtstrm cpuid
CPU implementer : 0x50
CPU architecture: 8
CPU variant     : 0x0
CPU part        : 0x000
CPU revision    : 0

Both exhibit the same error when building guix, just like the original
report, basically:

guix/cpu.scm:94:2: In procedure cpu->gcc-architecture:
In procedure struct-vtable: Wrong type argument in position 1 (expecting struct): #f
+ rm -r t-guix-manifest-18135
FAIL tests/guix-shell-export-manifest.sh (exit status: 1)

live well,
  vagrant